#!/usr/bin/env pybricks-micropython

# prod. by ACCP(Автономный Социалистичекский Союз Робототехников)

#импорт библиотек
import random
from pybricks.hubs import EV3Brick
from pybricks.ev3devices import (Motor, ColorSensor, UltrasonicSensor)
from pybricks.parameters import Port, Stop, Direction, Button, Color
from pybricks.tools import wait, StopWatch, DataLog
from pybricks.robotics import DriveBase
from pybricks.media.ev3dev import SoundFile, ImageFile
from pybricks import ev3brick as brick

#инициализация блока
ev3 = EV3Brick()

#инициализация моторов
b = Motor(Port.B, Direction.CLOCKWISE, None)#левый
c = Motor(Port.C, Direction.CLOCKWISE, None)#правый
r = DriveBase(b, c, wheel_diameter=36, axle_track=160)

#инициализация датчиков
c1 = ColorSensor(Port.S1)#правый
c2 = ColorSensor(Port.S2)#левый
c3 = ColorSensor(Port.S3)#центральный
c4 = ColorSensor(Port.S4)#препятствие и зона выгрузки

#обозначения цветов
wt = Color.WHITE
bk = Color.BLACK
bl = Color.BLUE
rd = Color.RED
yl = Color.YELLOW
gr = Color.GREEN
br = Color.BROWN

#переменные используемые в коде
rt = 0.0
trnvr = 0
angle = 0
x = 0
spd = 200 #скорость робота, возможно везде
spdln = 100 #скорость линии
bfw = 0 

#блоки

def move(rt): # блок на движение по прямой, на обороты, "move(x)", вместо x нужное кол-во оборотов
    r.stop() 
    trnvr = rt * 360 # переводим обороты в градусы
    b.run_angle(spd, trnvr, Stop.COAST, False)
    c.run_angle(spd, trnvr, Stop.COAST, True)

def rotate(angle): #блок для поворота робота, перед использованием блока написать переменную
    r.stop() #"rotate(x)" вместо х нужное число градусов("+" это направо, "-" налево)
    x = angle * 5.7
    b.run_angle(spd, x, Stop.COAST, False)
    c.run_angle(spd, -x, Stop.COAST, True)

def reset():
    r.stop()
    b.reset_angle(0)
    c.reset_angle(0)

def finder(side):#поиск линии
    global jew
    reset()
    if side == "left":
        print("finder for left\n_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_")
        while c3.color() != bk:
            rotate(-20)
            while c.angle() < 570*jew and c3.color() != bk: 
                b.run(-spdln)
                c.run( spdln)
            else:
                r.stop()
                while c.angle() > 0-(570*(jew-1)) and c3.color() != bk:
                    b.run( spdln)
                    c.run(-spdln)
                move(0.3)
                reset()
                jew += 0.1
            if c3.color() == bk:
                find = 0
        jew = 1 
        print('_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')
    if side == "right":
        print("finder for right\n_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_")
        rotate(20)
        while c3.color() != bk:
            while b.angle() < 570*jew and c3.color() != bk: 
                b.run( spdln)
                c.run(-spdln)
            else:
                r.stop()
                while b.angle() > 0-(570*(jew-1)) and c3.color() != bk:
                    b.run(-spdln)
                    c.run( spdln)
                move(0.3)
                reset()
                jew += 0.1
        reset()
        jew = 1
        print('_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')   
    if side == "180":
        print('еще не готово')

def line(): #езда по линии
    if c1.color() != bk and c2.color() != bk:
        b.run(spdln)
        c.run(spdln)
    if c1.color() != wt and c2.color() != bk and c3.color() != wt:
        reset()
        print('\n_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')
        print('2 black right')
        r.stop()
        print('c1 = ' + str(c1.color()) + ' c2 = ' + str(c2.color())+ ' c3 = ' + str(c3.color()))
        wait(300)
        print('c1 = ' + str(c1.color()) + ' c2 = ' + str(c2.color())+ ' c3 = ' + str(c3.color()))
        print('_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')
        if c1.color() != wt and c2.color() != bk and c3.color() != wt:
            move(0.2)
            finder('right')
    if c1.color() != bk and c2.color() != wt and c3.color() != wt:
        reset()
        print('\n_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')
        print('2 black left')
        print('c1 = ' + str(c1.color()) + ' c2 = ' + str(c2.color())+ ' c3 = ' + str(c3.color()))
        wait(300)
        print('c1 = ' + str(c1.color()) + ' c2 = ' + str(c2.color())+ ' c3 = ' + str(c3.color()))
        print('_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_-_')
        if c1.color() != bk and c2.color() != wt and c3.color() != wt:
            move(0.2)
            finder('left')
    if c1.color() != wt and c2.color() != bk and c3.color() != bk:
        r.drive(60, 350)
    if c1.color() != bk and c2.color() != wt and c3.color() != bk:
        r.drive(60, -350)
    if c1.color() != wt and c2.color() != wt and c3.color() != wt:
        print('здесь')
        move(0.2)

def folga():
    print("Kokos")
    # d.run_angle(100, 45)
    r.stop()
    while c1.color() != gr and c2.color() != gr and c3.color() != gr:
        if c4.color() == bk:
            print('выгрузить надо бы')
        elif c4.color() == wt:
            ang = 90
            trn()
            if c4.color() != None:
                ang = -180
                trn()
        else: 
            r.drive(100, 0)


while True:
    if Button.CENTER in brick.buttons():
        r.stop()
        print("СТАРТ")
        bfw = 1
    if Button.DOWN in brick.buttons():
        r.stop()
        bfw = 2
    if bfw == 1:# основной блок
        if Button.DOWN in brick.buttons():
            r.stop()
            bfw = 2
        else:
            if c1.color() == rd and c2.color() == rd and c3.color() == rd:
                r.stop()
                print("all red")
            elif c4.color() != None or c4.color() == wt:
                r.stop()
                print("c4 color: " + str(c4.color()))
                wait(200)
            
            else:
                if c1.color() == wt and c2.color() == wt and c3.color() == wt:
                    r.drive(spdln,0)
                    if c3.reflection() >= flg3:
                        if c1.reflection() >= flg1 and c2.reflection() >= flg2 and c3.reflection() >= flg3:
                            folga()
                        else:
                            r.drive(150, 0)
                    else:
                        r.drive(150, 0)
                else:
                    print('c1 = ' + str(c1.color()) + ' c2 = ' + str(c2.color())+ ' c3 = ' + str(c3.color()))
                    if c1.color() != gr and c2.color() != gr and c3.color() != gr:
                        print('line')
                        line()
                    else:
                        print('ne line')
                        if c1.color() == gr and c2.color() == gr:
                            print("Левый и правый - зеленый")
                            move(1)
                            rotate(120)
                            while c3.color() != bk:
                                b.run(150)
                                c.run(-150)
                            r.stop()
                        elif c1.color() == gr:
                            r.stop()
                            print('чето есть, вроде на правом')
                            while c1.color() != bk and c2.color() != bk:
                                if c1.color() != bk and c2.color() != bk:
                                    b.run(70)
                                    c.run(70)
                                if c1.color() != bk and c2.color() == bk:
                                    b.run(0)
                                    c.run(70)
                                if c1.color() == bk and c2.color() != bk:
                                    b.run(70)
                                    c.run(0)
                            move(-0.2)
                            wait(410)
                            if c1.color() == gr :#and c2.color() != gr:
                                print("Правый - зеленый")
                                move(1)
                                r.stop(Stop.COAST)
                                b.reset_angle(0)
                                c.reset_angle(0)
                                rotate(27)
                                while c3.color() != bk:
                                    if c3.color() != bk:
                                        while c3.color() != bk and b.angle() < 600:
                                            b.run(100)
                                            c.run(-100)
                                    if c3.color() != bk:
                                        while c3.color() != bk and b.angle() > 0:
                                            b.run(-175)
                                            c.run(175)
                                    if c3.color() != bk:
                                        move(1.3)
                                        r.stop(Stop.COAST)
                                        wait(200)
                                        b.reset_angle(0)
                                        c.reset_angle(0)
                        elif c2.color() == gr:
                            while c1.color() != bk and c2.color() != bk:
                                if c1.color() != bk and c2.color() != bk:
                                    b.run(50)
                                    c.run(50)
                                if c1.color() != bk and c2.color() == bk:
                                    b.run(0)
                                    c.run(50)
                                if c1.color() == bk and c2.color() != bk:
                                    b.run(50)
                                    c.run(0)
                            move(-0.2)
                            wait(420)
                            if c2.color() == gr and c1.color() != gr:
                                print("Левый - зеленый")
                                move(1)
                                r.stop(Stop.COAST)
                                b.reset_angle(0)
                                c.reset_angle(0)
                                rotate(-27)
                                while c3.color() != bk:
                                    if c3.color() != bk:
                                        while c3.color() != bk and b.angle() > -600:
                                            b.run(-100)
                                            c.run(100)
                                    if c3.color() != bk:
                                        while c3.color() != bk and b.angle() < 0:
                                            b.run(175)
                                            c.run(-175)
                                    if c3.color() != bk:
                                        move(1.3)
                                        r.stop(Stop.COAST)
                                        wait(200)
                                        b.reset_angle(0)
                                        c.reset_angle(0)
                        elif c3.color() == gr:
                            r.stop()
                            wait(400)
                            if c3.color() == gr:
                                print("средний - зеленый")
                                if c1.color() != wt:
                                    print("ищем линию направо")
                                    r.stop()
                                    wait(200)
                                    while c3.color() != bk:
                                        b.run(150)
                                        c.run(-150)
                                    r.stop()
                                    move(-0.2)
                                elif c2.color() != wt:
                                    print("ищем линию налево")
                                    r.stop()
                                    wait(200)
                                    while c3.color() != bk:
                                        b.run(-150)
                                        c.run(150)   
                                    move(-0.2)
                                else:
                                    rotate(2)
                                    move(-0.05)
                        else:
                            print("broke")
                            print("c1 = " + str(c1.color()) + " c2 = " + str(c2.color()) + ' c3 = ' + str(c3.color())) #' c4 = ' + str(c4.color()))
    elif bfw == 2:#блок остановки по кнопке
        r.stop()
        bfw = 0
    elif bfw == 2:#блок остановки по кнопке
        r.stop()
        bfw = 0
    elif bfw == 3:# калибровка фольги
        r.stop()
        brick.sound.beep(1500, 200)
        if value == 0:
            flg1 = 0
            flg2 = 0
            flg3 = 0
            rfl1 = 0
            rfl2 = 0
            rfl3 = 0
        value += 1
        rfl1 += int(c1.reflection())
        rfl2 += int(c2.reflection())
        rfl3 += int(c3.reflection())
        print("1 is " + str(c1.reflection()) + ". 2 is " + str(c2.reflection()) + ". 3 is " + str(c3.reflection()) + "\n")
        flg1 = (rfl1 // value) - 5
        flg2 = (rfl2 // value) - 5
        flg3 = (rfl3 // value) - 5
        print("value = " + str(value))
        print ("folga dlya 1  = " + str(flg1) + ". folga dlya 2  = " + str(flg2) + ". folga dlya 3  = " + str(flg3) + "\n________")
    elif bfw == 4: # блок для тестов/отладки программы
        print('hgsdj')
    elif bfw == 5:
        print("Left is " + str(c1.color()) + "\n Right is " + str(c2.color()) + "\n Middle is " + str(c3.color()) + "\n ______________________________________________________")
        wait(600)